package com.ff.weijinxiao.service;


import com.ff.weijinxiao.domain.MemberAndService;
import com.ff.weijinxiao.repository.MemberAndServiceRepository;
import com.ff.weijinxiao.util.SpecificationUtil;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Pageable;
import org.springframework.data.domain.Sort;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;
import java.util.Optional;

@Service
public class MemberAndServiceService {

    @Resource
    private MemberAndServiceRepository memberAndServiceRepository;

    /**
     * 创建实体
     *
     * @param memberAndService
     */
    public MemberAndService saveMemberAndService(MemberAndService memberAndService) {
        return memberAndServiceRepository.save(memberAndService);
    }

    /**
     * 查找实体
     *
     * @param id
     * @return
     */
    public MemberAndService findById(Integer id) {
        Optional<MemberAndService> optional = memberAndServiceRepository.findById(id);
        if (optional.isPresent()) {
            return optional.get();
        } else {
            return null;
        }
    }

    public void deleteById(Integer id) {
        memberAndServiceRepository.deleteById(id);
    }

    /**
     * 分页条件查询
     *
     * @param page
     * @param size
     * @param param
     * @return
     */
    public Page<MemberAndService> findPage(int page, int size, Map<String, Object> param) {
        Sort.Direction direction = Sort.Direction.DESC;
        String sort = "id";
        Pageable pageable = new PageRequest(page - 1, size, direction, sort);
        return memberAndServiceRepository.findAll(SpecificationUtil.buildSpecification(param, MemberAndService.class), pageable);
    }

    /**
     * 根据条件查询List
     */
    public List<MemberAndService> findList(Map<String, Object> param) {
        return memberAndServiceRepository.findAll(SpecificationUtil.buildSpecification(param, MemberAndService.class));
    }

}
